# generated by datamodel-codegen:
#   filename:  api/domains/createDataProduct.json
#   timestamp: 2025-01-20T14:41:40+00:00

from __future__ import annotations

from typing import List, Optional

from pydantic import ConfigDict, Field
from typing_extensions import Annotated

from metadata.ingestion.models.custom_pydantic import BaseModel

from ...type import basic, entityReferenceList


class CreateDataProductRequest(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: Annotated[
        basic.EntityName, Field(description='A unique name of the DataProduct')
    ]
    fullyQualifiedName: Annotated[
        Optional[basic.FullyQualifiedEntityName],
        Field(None, description='FullyQualifiedName of the Domain.'),
    ]
    displayName: Annotated[
        Optional[str],
        Field(
            None,
            description="Name used for display purposes. Example 'Customer Churn', 'Sentiment Analysis', etc.",
        ),
    ]
    description: Annotated[
        basic.Markdown, Field(description='Description of the DataProduct.')
    ]
    style: Optional[basic.Style] = None
    owners: Annotated[
        Optional[entityReferenceList.EntityReferenceList],
        Field(None, description='Owners of this DataProduct.'),
    ]
    domain: Annotated[
        Optional[basic.FullyQualifiedEntityName],
        Field(
            None,
            description='Fully qualified name of the Domain the DataProduct belongs to.',
        ),
    ]
    experts: Annotated[
        Optional[List[str]],
        Field(
            None,
            description='List of user/login names of users who are experts in this DataProduct.',
        ),
    ]
    assets: Annotated[
        Optional[entityReferenceList.EntityReferenceList],
        Field(
            None,
            description='Data assets collection that is part of this data product.',
        ),
    ]
    extension: Annotated[
        Optional[basic.EntityExtension],
        Field(
            None,
            description='Entity extension data with custom attributes added to the entity.',
        ),
    ]
