# generated by datamodel-codegen:
#   filename:  api/services/createDashboardService.json
#   timestamp: 2025-01-20T14:41:40+00:00

from __future__ import annotations

from typing import List, Optional

from pydantic import ConfigDict, Field
from typing_extensions import Annotated

from metadata.ingestion.models.custom_pydantic import BaseModel

from ...entity.services import dashboardService
from ...type import basic, entityReferenceList, tagLabel


class CreateDashboardServiceRequest(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    name: Annotated[
        basic.EntityName,
        Field(description='Name that identifies the this entity instance uniquely'),
    ]
    displayName: Annotated[
        Optional[str],
        Field(None, description='Display Name that identifies this dashboard service.'),
    ]
    description: Annotated[
        Optional[basic.Markdown],
        Field(None, description='Description of dashboard service entity.'),
    ]
    serviceType: dashboardService.DashboardServiceType
    connection: Optional[dashboardService.DashboardConnection] = None
    tags: Annotated[
        Optional[List[tagLabel.TagLabel]],
        Field(None, description='Tags for this Dashboard Service.'),
    ]
    owners: Annotated[
        Optional[entityReferenceList.EntityReferenceList],
        Field(None, description='Owners of this dashboard service.'),
    ]
    dataProducts: Annotated[
        Optional[List[basic.FullyQualifiedEntityName]],
        Field(
            None,
            description='List of fully qualified names of data products this entity is part of.',
        ),
    ]
    domain: Annotated[
        Optional[str],
        Field(
            None,
            description='Fully qualified name of the domain the Dashboard Service belongs to.',
        ),
    ]
