# generated by datamodel-codegen:
#   filename:  entity/services/connections/dashboard/modeConnection.json
#   timestamp: 2025-01-20T14:41:40+00:00

from __future__ import annotations

from enum import Enum
from typing import Optional

from pydantic import AnyUrl, ConfigDict, Field
from typing_extensions import Annotated

from metadata.ingestion.models.custom_pydantic import BaseModel, CustomSecretStr

from .. import connectionBasicType


class ModeType(Enum):
    Mode = 'Mode'


class ModeConnection(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    type: Annotated[
        Optional[ModeType],
        Field(ModeType.Mode, description='Service Type', title='Service Type'),
    ]
    hostPort: Annotated[
        Optional[AnyUrl],
        Field(
            'https://app.mode.com',
            description='URL for the mode instance.',
            title='Host and Port',
        ),
    ]
    accessToken: Annotated[
        str, Field(description='Access Token for Mode Dashboard', title='Access Token')
    ]
    accessTokenPassword: Annotated[
        CustomSecretStr,
        Field(
            description='Access Token Password for Mode Dashboard',
            title='Access Token Password',
        ),
    ]
    workspaceName: Annotated[
        str, Field(description='Mode Workspace Name', title='Workspace Name')
    ]
    filterQueryParam: Annotated[
        Optional[str],
        Field(
            None,
            description='Filter query parameter for some of the Mode API calls',
            title='Filter Query Param',
        ),
    ]
    supportsMetadataExtraction: Annotated[
        Optional[connectionBasicType.SupportsMetadataExtraction],
        Field(None, title='Supports Metadata Extraction'),
    ]
