# generated by datamodel-codegen:
#   filename:  entity/services/connections/dashboard/mstrConnection.json
#   timestamp: 2025-01-20T14:41:40+00:00

from __future__ import annotations

from enum import Enum
from typing import Optional

from pydantic import AnyUrl, ConfigDict, Field
from typing_extensions import Annotated

from metadata.ingestion.models.custom_pydantic import BaseModel, CustomSecretStr

from .. import connectionBasicType


class MstrType(Enum):
    Mstr = 'Mstr'


class MstrConnection(BaseModel):
    model_config = ConfigDict(
        extra='forbid',
    )
    type: Annotated[
        Optional[MstrType],
        Field(MstrType.Mstr, description='Service Type', title='Service Type'),
    ]
    username: Annotated[
        str,
        Field(
            description='Username to connect to MSTR. This user should have privileges to read all the metadata in MSTR.',
            title='Username',
        ),
    ]
    password: Annotated[
        Optional[CustomSecretStr],
        Field(None, description='Password to connect to MSTR.', title='Password'),
    ]
    hostPort: Annotated[
        AnyUrl,
        Field(
            description='Host and Port of the Metabase instance.', title='Host and Port'
        ),
    ]
    projectName: Annotated[
        Optional[str],
        Field(None, description='MSTR Project Name', title='Project Name'),
    ]
    supportsMetadataExtraction: Annotated[
        Optional[connectionBasicType.SupportsMetadataExtraction],
        Field(None, title='Supports Metadata Extraction'),
    ]
